﻿Imports System.Collections.ObjectModel
Imports MindFusion.Charting

Public Class MainForm

	Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
		Dim plot = DirectCast(radarChart.Plot, RadarPlot)

		' create sample data, a list of .NET objects
		Dim data = CreateData()
		For i As Integer = 0 To 4
			plot.Axes.Add(New Axis() With {.Title = data(i).Subject, .MinValue = 0, .MaxValue = 4})
		Next

		' set the data source and specify property names to use as data
		radarChart.XDataFields = New ObservableCollection(Of String)() From { _
		 "GPA1", _
		 "GPA2", _
		 "GPA3" _
		}
		radarChart.YDataFields = New ObservableCollection(Of String)() From { _
		 "GPA1", _
		 "GPA2", _
		 "GPA3" _
		}

		radarChart.InnerLabelsDataFields = New ObservableCollection(Of String)() From { _
		 "GPA1", _
		 "GPA2", _
		 "GPA3" _
		}
		radarChart.ToolTipsDataFields = New ObservableCollection(Of String)() From { _
		 "Subject", _
		 "Subject", _
		 "Subject" _
		}
		radarChart.DataSource = data
		radarChart.DataBind()

		' set the series titles
		DirectCast(radarChart.Series(0), DataBoundSeries).Title = "age range 7-10"
		DirectCast(radarChart.Series(1), DataBoundSeries).Title = "age range 11-13"
		DirectCast(radarChart.Series(2), DataBoundSeries).Title = "age range 14-17"

		' set up legend
		radarChart.LegendTitle = "GPA by subject and age"
		radarChart.Theme.LegendBackground = New MindFusion.Drawing.SolidBrush(Color.White)
		radarChart.AllowMoveLegend = False

		' customize appearance
		radarChart.ShowCoordinates = False
		radarChart.Plot.Margin = New Margins(0, 0, 0, 30)
		radarChart.GridColor1 = Color.White
		radarChart.GridColor2 = Color.FromArgb(240, 240, 240)
		radarChart.Theme.HighlightStroke = New MindFusion.Drawing.SolidBrush(Color.Gold)
		radarChart.Theme.AxisTitleFontStyle = FontStyle.Underline
		radarChart.Theme.LegendTitleFontStyle = FontStyle.Underline
		radarChart.Theme.AxisStroke = New MindFusion.Drawing.SolidBrush(Color.LightGray)
		radarChart.Theme.CommonSeriesFills = New List(Of MindFusion.Drawing.Brush)() From {
		New MindFusion.Drawing.SolidBrush(Color.FromArgb(102, 154, 204)),
		New MindFusion.Drawing.SolidBrush(Color.FromArgb(0, 0, 99)),
		New MindFusion.Drawing.SolidBrush(Color.FromArgb(206, 0, 0))
		}
		radarChart.Theme.CommonSeriesStrokes = New List(Of MindFusion.Drawing.Brush)() From {
		New MindFusion.Drawing.SolidBrush(Color.FromArgb(102, 154, 204)),
		New MindFusion.Drawing.SolidBrush(Color.FromArgb(0, 0, 99)),
		New MindFusion.Drawing.SolidBrush(Color.FromArgb(206, 0, 0))
		}
		radarChart.Theme.UniformSeriesStrokeThickness = 5

	End Sub

	Public Function CreateData() As List(Of StudentData)
		Dim data As New List(Of StudentData)()

		Dim subjects As String() = New String(4) {"Math", "Physics", "Chemistry", "Biology", "IT"}
		Dim gpa1 As Single() = New Single(4) {2.3F, 1.7F, 2, 4, 3.7F}
		Dim gpa2 As Single() = New Single(4) {3.3F, 2.7F, 1.7F, 2, 3.3F}
		Dim gpa3 As Single() = New Single(4) {4, 3.7F, 2, 1, 1.3F}

		For i As Integer = 0 To 4
			data.Add(New StudentData() With {.Subject = subjects(i), .GPA1 = gpa1(i), .GPA2 = gpa2(i), .GPA3 = gpa3(i)})
		Next

		Return data
	End Function

	Private Sub checkBox1_CheckedChanged(sender As Object, e As System.EventArgs) Handles checkBox1.CheckedChanged
		radarChart.RadarType = If(radarChart.RadarType = RadarType.Pie, RadarType.Polygon, RadarType.Pie)
		checkBox1.Text = If(radarChart.RadarType = RadarType.Pie, "RadarType=Pie", "RadarType=Polygon")
	End Sub

	Private Sub checkBox2_CheckedChanged(sender As Object, e As System.EventArgs) Handles checkBox2.CheckedChanged
		radarChart.GridType = If(radarChart.GridType = RadarGridType.Radar, RadarGridType.Spiderweb, RadarGridType.Radar)
		checkBox2.Text = If(radarChart.GridType = RadarGridType.Radar, "GridType=Radar", "GridType=Spiderweb")
	End Sub

	Private Sub checkBox3_CheckedChanged(sender As Object, e As System.EventArgs) Handles checkBox3.CheckedChanged
		radarChart.ShowScatter = checkBox3.Checked
	End Sub
End Class

Public Class StudentData
	Public Sub New()
	End Sub

	Public Property Subject() As String
		Get
			Return m_Subject
		End Get
		Set(value As String)
			m_Subject = Value
		End Set
	End Property
	Private m_Subject As String
	Public Property GPA1() As Single
		Get
			Return m_GPA1
		End Get
		Set(value As Single)
			m_GPA1 = Value
		End Set
	End Property
	Private m_GPA1 As Single
	Public Property GPA2() As Single
		Get
			Return m_GPA2
		End Get
		Set(value As Single)
			m_GPA2 = Value
		End Set
	End Property
	Private m_GPA2 As Single
	Public Property GPA3() As Single
		Get
			Return m_GPA3
		End Get
		Set(value As Single)
			m_GPA3 = Value
		End Set
	End Property
	Private m_GPA3 As Single
End Class

